package CropHarvester;

import org.bukkit.Sound;
import org.bukkit.Tag;
import org.bukkit.block.Block;
import org.bukkit.block.data.Ageable;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;

import java.util.Objects;

public class CropHarvester implements Listener {

    @EventHandler
    public void playerRightClick(PlayerInteractEvent e){

        if(!Objects.requireNonNull(e.getHand()).isHand())return;
        if(!checkForFullGrownCrop(e))return;

        Player player = e.getPlayer();

        player.sendMessage(Objects.requireNonNull(e.getClickedBlock()).getType().toString());

        e.getClickedBlock().breakNaturally();
        player.playSound(e.getClickedBlock().getLocation(), Sound.BLOCK_CROP_BREAK,1,1);
    }


    //returns false on fail
    private boolean checkForFullGrownCrop(PlayerInteractEvent e){

        if(!e.getAction().equals(Action.RIGHT_CLICK_BLOCK))return false; //check for right click on a block

        Block clickedBlock = e.getClickedBlock();

        if(!Tag.CROPS.isTagged(Objects.requireNonNull(clickedBlock).getType()))return false; //check if the clicked block is a type of crop

        Ageable ageable = (Ageable) clickedBlock.getBlockData();
        if(ageable.getAge() != ageable.getMaximumAge())return false;


        return true;
    }

}
